//#include "config.h"
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#include <X11/Xmu/WinUtil.h>
#include <glib-2.0/glib.h>


// g++ -o ./iconrun2 ./iconrun2.c  -lImlib2 -lX11 -lXmu `pkg-config --cflags --libs glib-2.0`

/*
#include <sys/time.h>
#include "common.h"
#include "image.h"
#include "rend.h"
#include "rgba.h"
#include "ximage.h"
#include "color.h"
 */
#include "Imlib2.h"

Display            *disp;
Window              win;
Window              win2;
Window              win3;
Visual             *vis;
Colormap            cm;
int                 depth;
XSetWindowAttributes attr;
char *appToRun;
int i3;
int mytoggle = 0;
Imlib_Image         buffer3;
Imlib_Font          font3;
int bord=0;
double trans_wind=0.85;
char *title;
char *skip;

#include "./other_src/wm_ctrl.c"


void init_window(int win_id)
{

  unsigned long action;
  gchar *tmp_prop2, *tmp2;
  gchar *tmp_prop1, *tmp1;
  char *p1="maximized_vert", *p2="maximized_horz";
  Atom prop1 = 0;
  Atom prop2 = 0;
  action = _NET_WM_STATE_REMOVE;
  tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
  p_verbose("State 2: %s\n", tmp_prop2); 
  prop2 = XInternAtom(disp, tmp_prop2, False);
  tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
  p_verbose("State 1: %s\n", tmp_prop1); 
  prop1 = XInternAtom(disp, tmp_prop1, False);
  client_msg(disp, win_id, "_NET_WM_STATE", 
    action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
  p1="fullscreen";
  p2="above";
  prop1 = 0;
  prop2 = 0;
  action = _NET_WM_STATE_REMOVE;
  tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
  p_verbose("State 2: %s\n", tmp_prop2); 
  prop2 = XInternAtom(disp, tmp_prop2, False);
  tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
  p_verbose("State 1: %s\n", tmp_prop1); 
  prop1 = XInternAtom(disp, tmp_prop1, False);
  client_msg(disp, win_id, "_NET_WM_STATE", 
      action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
}

/* nothing fancy */
int trans(double d, Window target_win)
{
  #define OPAQUE	0xffffffff
  #define OPACITY	"_NET_WM_WINDOW_OPACITY"
  unsigned int opacity;

  opacity = (unsigned int) (d * OPAQUE);
  XChangeProperty(disp, target_win, XInternAtom(disp, OPACITY, False), 
		    XA_CARDINAL, 32, PropModeReplace, 
		    (unsigned char *) &opacity, 1L);
  XSync(disp, False);
  return 0;
}

void exposelist(void);

int main(int argc, char **argv)
{
  int                 w, h, x, y;
  Imlib_Image         im_bg = NULL;
  XEvent              ev;
  const char         *display_name = getenv("DISPLAY");
  Imlib_Image         buffer;
  Imlib_Image         back;
  Imlib_Image         bigback;
  Imlib_Font          font;
  char                text[4096];
  Imlib_Color_Range   range;
  int  text_w, text_h;
  if (display_name == NULL)
    display_name = ":0";
  disp = XOpenDisplay(display_name);
  if (disp == NULL)
  {
    fprintf(stderr, "Can't open display %s\n", display_name);
    return 1;
  }

  int screen=DefaultScreen(disp);
  int screenWidth=0;
  screenWidth=XDisplayWidth(disp,screen);
  screenWidth=64;
  int screenHeight;
  screenHeight=64;
  int screenX=10;
  int screenY=10;
  int lowerraise=0;
  char group[1024];
  char picname[1024];
  char tag[1024];
  int xl=0;
  int yl=0;
  int mytoggle = 0;
  int mytoggle2 = 0;
  int store=0;
  int autohideSubbutton=0;
  int MouseMoveOpenSubIcon=0;
  int s_g;
  char *win_move;

  double trans_icon=0.65;

  char submenue[1000];
  char home[1024];
  sprintf(home,"%s",getenv("HOME"));
  if ( home == "" )
  {
    printf("fatal error: no /home/xxx found!\n");
    return 1;
  }
  Window              cur_win_id;

  if (( argc != 19 ) and ( argc != 17 ))
  {
    printf("usage1: iconrun2 x y width height lower/raise(0/1) autohideSubbutton(0/1/2) MouseMoveOpenSubIcon(0/1) group single/group(0)  windows_class_for_skip windows_move_to(x,y,w,h) bord(0/1) trans_icon trans_wind image tag application title\n");
    printf("usage2: iconrun2 x y width height lower/raise(0/1) autohideSubbutton(0/1/2) MouseMoveOpenSubIcon(0/1) group single/group(1)  windows_class_for_skip windows_move_to(x,y,w,h) bord(0/1) trans_icon trans_wind image tag\n");
    return 1;
  }

  sscanf(argv[1], "%d", &screenX);
  sscanf(argv[2], "%d", &screenY);
  sscanf(argv[3], "%d", &screenWidth);
  sscanf(argv[4], "%d", &screenHeight);
  sscanf(argv[5], "%d", &lowerraise);
  sscanf(argv[6], "%d", &autohideSubbutton);
  sscanf(argv[7], "%d", &MouseMoveOpenSubIcon);
  sscanf(argv[8], "%s", &group);
  sscanf(argv[9], "%d", &s_g);
  skip=argv[10];
  win_move=argv[11];
  sscanf(argv[12], "%d", &bord);
  trans_icon = atof (argv[13]);
  trans_wind = atof (argv[14]);
  sscanf(argv[15], "%s", &picname);

  if (s_g==1)
  {
    sscanf(argv[16], "%s", &tag);
  }
  
  if (s_g==0)
  {
    appToRun = argv[16];
    sscanf(argv[17], "%s", &tag);
    printf("%s",appToRun);
    title=argv[18];
  }
  
  vis = DefaultVisual(disp, DefaultScreen(disp));
  depth = DefaultDepth(disp, DefaultScreen(disp));
  cm = DefaultColormap(disp, DefaultScreen(disp));
        // text
  range = imlib_create_color_range();
  imlib_context_set_color_range(range);
  imlib_context_set_color(255, 255, 255, 255);
  imlib_add_color_to_color_range(0);
  /* add an orange color, semi-transparent 10 units from the first */
  imlib_context_set_color(255, 200, 10, 255);
  imlib_add_color_to_color_range(10);
  /* add black, fully transparent at the end 20 units away */
  imlib_context_set_color(70, 0, 0, 255);
  imlib_add_color_to_color_range(20);

  attr.override_redirect=True;
 //win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,CopyFromParent,InputOutput,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask|CWBorderPixel|CWSaveUnder|CWColormap|CWBackPixel,&attr);
  win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
//   win =  XCreateSimpleWindow(disp, DefaultRootWindow(disp), 0, 0, 100, 100, 0, 0, 0);
  XSelectInput(disp, win, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
  XMapWindow(disp, win);

  if(lowerraise==0)
     XLowerWindow(disp,win);
  if(lowerraise==1)
     XRaiseWindow(disp,win);
  trans(trans_icon,win);

   /**
    * Start rendering
    */

  imlib_context_set_display(disp);
  imlib_context_set_visual(vis);
  imlib_context_set_colormap(cm);
  imlib_context_set_drawable(win);
  imlib_context_set_dither(1);
  imlib_context_set_blend(0);
  imlib_context_set_color_modifier(NULL);

//--
  w=screenWidth;
  h=screenHeight;
  char back_pic[1280];
  sprintf(back_pic,"%s/.icon-DE/pics/background.png",home);
  if (access(back_pic,0)==-1)
    sprintf(back_pic,"/usr/share/icon-DE/pics/background.png");
  back = imlib_load_image(back_pic);
  imlib_context_set_image(back);
  buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() , w , h);
  im_bg = imlib_load_image(picname);
  XMapWindow(disp, win);
  imlib_context_set_image(im_bg);

  int is=imlib_image_get_width();
  int ih=imlib_image_get_height();
  int d1=screenWidth-is;
  d1=d1/2;
  int d2=screenHeight-ih;
  d2=d2/2;
  int i=0;
  int cur_win=0;
  imlib_context_set_image(im_bg);
  imlib_context_set_blend(1);

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg);
  imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
  bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg);

  imlib_render_image_on_drawable(d1, d2);
  back=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  XResizeWindow(disp, win, w, h);
  XSync(disp, False);
  if (autohideSubbutton==1)
     XMoveWindow(disp,win,-screenWidth+2 , screenY);
  if (autohideSubbutton==2)
     XMoveWindow(disp,win,-screenWidth/2 , screenY);

  char font_path[1024];
  sprintf(font_path,"%s/.icon-DE/fonts",home);
  imlib_add_path_to_font_path(font_path);
  imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");

  x = -9999;
  y = -9999;
  x = -screenWidth/2;
  y = -screenHeight/2;
  int can_close,cur_times;
  can_close=0;
  cur_times=0;
  int tra=0;
  while (1)
  {
    do
    {
      XNextEvent(disp, &ev);
      switch (ev.type)
      {
      case Expose:
        break;
      case MotionNotify:
        x = ev.xmotion.x;
        y = ev.xmotion.y;
      default:
        break;
      case EnterNotify:		
        if(lowerraise==0)
           XLowerWindow(disp,win);
        if(lowerraise==1)
           XRaiseWindow(disp,win);
        mytoggle = 1;
        system("killall iconrun3");	
        buffer = imlib_create_image(1000, 30);  
        font = imlib_load_font("Vera/8");
        if (font == NULL)
          font = imlib_load_font("wqy-zenhei.ttc/8");
        imlib_context_set_font(font);
        imlib_context_set_color(0, 0, 0, 255);
        sprintf(text,"%s",tag);
        imlib_get_text_size(text, &text_w, &text_h);
        win2=XCreateWindow(disp,DefaultRootWindow(disp),screenX+screenWidth+4,screenY-18,text_w+40,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
        XRaiseWindow(disp,win2);
        XMapWindow(disp, win2);
        imlib_context_set_drawable(win2); 
//        imlib_context_set_image(buffer);
           /* draw the range */
        imlib_context_set_image(buffer);
        imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
           /* free it */
      //     imlib_free_color_range();
        imlib_context_set_image(buffer);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer);
        imlib_context_set_font(font);
        imlib_context_set_color(0, 0, 0, 255);
        imlib_text_draw(5,2,text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer);
        imlib_context_set_drawable(win2); 
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer);
        imlib_free_image();
        imlib_context_set_font(font);
        imlib_free_font();
        imlib_context_set_image(im_bg);
        imlib_context_set_drawable(win);

        XMoveWindow(disp,win,screenX , screenY);

        if (((MouseMoveOpenSubIcon==1) or (MouseMoveOpenSubIcon==2)) and (s_g==1))
        {
          sprintf(submenue , "icon-wharf %d %d %s %d %d" , screenWidth+screenX , screenY , group , lowerraise, bord);
          system(submenue);	
        }
        break;
      case LeaveNotify:		
        x = -screenWidth/2;
        y = -screenHeight/2;
        if ( mytoggle2 == 1)
        {
          if (win_pid_list[cur_win]!=0)
          {
            init_window(win_pid_list[cur_win]);
            action_window(disp,win_pid_list[cur_win],'a');
            window_move_resize(disp,win_pid_list[cur_win],win_move);
          }  
          mytoggle2 = 0;
        }    
        mytoggle = 0;
        XDestroyWindow(disp,win2);	
        store=0;
//2012.04.04
        if (autohideSubbutton==1) 
          XMoveWindow(disp,win,-screenWidth+2 , screenY);
        if (autohideSubbutton==2) 
          XMoveWindow(disp,win,-screenWidth/2 , screenY);

//2012.04.04
        break;
      case ButtonPress:				
        if(ev.xbutton.button==1)
        {
          if (s_g==0)
          {
            system("killall iconrun3");	   
            exposelist();
            if (MouseMoveOpenSubIcon==1) 
              system("killall iconrun2 2>/dev/null");	
          }
          if (s_g==1)
          {
            if(store==1)
            {
              store=0;
              break;
            }
            sprintf(submenue , "icon-wharf %d %d %s %d %d" , screenWidth+screenX , screenY , group , lowerraise, bord);
            system(submenue);	
            store+=1;
          }
        } 
        if(ev.xbutton.button==2)
        {
          double t=atof(group);
          if (t>=10) t=10;
          t=t/10;
          if (get_active_window(disp)!=0)
          if (tra==0)
          {
            sprintf(submenue , "icon-trans %f 2" , t);
            system(submenue);	
            tra=1;
          } else {
            sprintf(submenue , "icon-trans 1 2");
            system(submenue);	
            tra=0;
          } 
          break;
        }
        if(ev.xbutton.button==3)
        {
       /* if we click anywhere in the window, exit */
          system("killall iconrun3");	
          if (MouseMoveOpenSubIcon==1)
            system("killall iconrun2 2>/dev/null");	
//                                   exit(0);
          break;
        }
        if(ev.xbutton.button==4)
        {
          if (s_g==0)
          {
            cur_times=cur_times+1;
            if ((can_close==1) or (cur_times>=3))
            {
              system("killall iconrun3");	
              if (MouseMoveOpenSubIcon==1)
                system("killall iconrun2 2>/dev/null");	
            }
            list_windows(disp,skip);
            if (get_active_window(disp)==0)
            {
              for (i=0;i<win_count;i++)
              {
                if (win_pid_list[i]!=0) 
                if (get_window_title(disp,win_pid_list[i])!=NULL)
                if (strstr(get_window_title(disp,win_pid_list[i]),title)!=NULL)
                {
                  action_window(disp,win_pid_list[i],'a');
                  can_close=0;
                }  
              }   
            } else {
              if ( get_window_title(disp,get_active_window(disp))!=NULL)
              {
                unsigned long action;
                gchar *tmp_prop2, *tmp2;
                gchar *tmp_prop1, *tmp1;
                char *p1="maximized_vert", *p2="maximized_horz";
                Atom prop1 = 0;
                Atom prop2 = 0;
                can_close=1;

                action = _NET_WM_STATE_REMOVE;
                tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                p_verbose("State 2: %s\n", tmp_prop2); 
                prop2 = XInternAtom(disp, tmp_prop2, False);
                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                p_verbose("State 1: %s\n", tmp_prop1); 
                prop1 = XInternAtom(disp, tmp_prop1, False);
                client_msg(disp, get_active_window(disp), "_NET_WM_STATE", 
                  action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                p1="fullscreen";
                p2="above";
                prop1 = 0;
                prop2 = 0;
                action = _NET_WM_STATE_REMOVE;
                tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                p_verbose("State 2: %s\n", tmp_prop2); 
                prop2 = XInternAtom(disp, tmp_prop2, False);
                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                p_verbose("State 1: %s\n", tmp_prop1); 
                prop1 = XInternAtom(disp, tmp_prop1, False);
                g_free(tmp1);
                g_free(tmp_prop1);
                g_free(tmp2);
                g_free(tmp_prop2);
                client_msg(disp, get_active_window(disp), "_NET_WM_STATE", 
                      action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                if (strstr(get_window_title(disp,get_active_window(disp)),title)==NULL)
                {
                  for (i=0;i<win_count;i++)
                  {
                    if (win_pid_list[i]!=0) 
                    if (get_window_title(disp,win_pid_list[i])!=NULL)
                    if (strstr(get_window_title(disp,win_pid_list[i]),title)!=NULL)
                    {
                      action_window(disp,win_pid_list[i],'a');
                      can_close=0;
                    }  
                  }   
                }  else {
                  if (get_active_window(disp)!=0)
                  {
                    cur_win_id=get_active_window(disp);
                    unsigned long action;
                    gchar *tmp_prop2, *tmp2;
                    gchar *tmp_prop1, *tmp1;
                    char *p1="maximized_vert", *p2="maximized_horz";
                    Atom prop1 = 0;
                    Atom prop2 = 0;
                    can_close=1;

                    action = _NET_WM_STATE_REMOVE;
                    tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                    p_verbose("State 2: %s\n", tmp_prop2); 
                    prop2 = XInternAtom(disp, tmp_prop2, False);
                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                    p_verbose("State 1: %s\n", tmp_prop1); 
                    prop1 = XInternAtom(disp, tmp_prop1, False);
                    client_msg(disp, cur_win_id, "_NET_WM_STATE", 
                      action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                    p1="fullscreen";
                    p2="above";
                    prop1 = 0;
                    prop2 = 0;
                    action = _NET_WM_STATE_REMOVE;
                    tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                    p_verbose("State 2: %s\n", tmp_prop2); 
                    prop2 = XInternAtom(disp, tmp_prop2, False);
                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                    p_verbose("State 1: %s\n", tmp_prop1); 
                    prop1 = XInternAtom(disp, tmp_prop1, False);
                    g_free(tmp1);
                    g_free(tmp_prop1);
                    g_free(tmp2);
                    g_free(tmp_prop2);
                    client_msg(disp, cur_win_id, "_NET_WM_STATE", 
                          action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
//                    printf("%s %d \n",win_move,cur_win_id);
                    window_move_resize(disp,cur_win_id,win_move);
                  }
                }  
              }
            } 
          }  else {
            list_windows(disp,skip);
            if (win_pid_list[cur_win]==0)
            {
              cur_win=0;
              sprintf(text,"没有活动窗口");
            }  else  {
              if (get_window_title(disp,win_pid_list[cur_win])!=NULL)
              {
                if (cur_win<win_count-1) {
                  cur_win=cur_win+1;  
                } else  {
                  cur_win=0;  
                } 
                sprintf(text,"%s",get_window_title(disp,win_pid_list[cur_win]));
                mytoggle = 1;
                mytoggle2 = 1;
              } else {
                sprintf(text,"没有活动窗口");
                cur_win=0;  
              }    
            } 
            mytoggle = 1;
            buffer = imlib_create_image(1000, 30);  
            font = imlib_load_font("Vera/8");
            if (font == NULL)
              font = imlib_load_font("wqy-zenhei.ttc/8");
            imlib_context_set_font(font);
            imlib_context_set_color(0, 0, 0, 255);
            imlib_get_text_size(text, &text_w, &text_h);
//            win2=XCreateWindow(disp,DefaultRootWindow(disp),screenX+screenWidth+4,screenY-18,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
            XRaiseWindow(disp,win2);
            XMapWindow(disp, win2);
            imlib_context_set_drawable(win2); 
//            imlib_context_set_image(buffer);
            imlib_context_set_image(buffer);
            imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
      //     imlib_free_color_range();
            imlib_context_set_image(buffer);
            imlib_render_image_on_drawable(0, 0); 
            imlib_context_set_image(buffer);
            imlib_context_set_font(font);
            imlib_context_set_color(0, 0, 0, 255);
            imlib_text_draw(5,2,text);
            imlib_context_set_image(buffer);
            imlib_context_set_drawable(win2); 
            imlib_render_image_on_drawable(0, 0); 
            imlib_context_set_image(buffer);
            imlib_free_image();
            imlib_context_set_font(font);
            imlib_free_font();
            imlib_context_set_image(im_bg);
            imlib_context_set_drawable(win); 
            system("killall iconrun3");	
          }
          break;
        }
        if(ev.xbutton.button==5)
        {
          if (s_g==0)
          {
            cur_times=cur_times+1;
            if ((can_close==1) or (cur_times>=3))
            {
              system("killall iconrun3");	
              if (MouseMoveOpenSubIcon==1)
                system("killall iconrun2 2>/dev/null");	
            }
            list_windows(disp,skip);
            if (get_active_window(disp)==0)
            {
              for (i=0;i<win_count;i++)
              {
                if (win_pid_list[i]!=0) 
                if (get_window_title(disp,win_pid_list[i])!=NULL)
                if (strstr(get_window_title(disp,win_pid_list[i]),title)!=NULL)
                {
                  action_window(disp,win_pid_list[i],'a');
                  can_close=0;
                }  
              }   
            } else {
              if (get_window_title(disp,get_active_window(disp))!=NULL)
              {
                unsigned long action;
                gchar *tmp_prop2, *tmp2;
                gchar *tmp_prop1, *tmp1;
                char *p1="maximized_vert", *p2="maximized_horz";
                Atom prop1 = 0;
                Atom prop2 = 0;
                can_close=1;

                action = _NET_WM_STATE_REMOVE;
                tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                p_verbose("State 2: %s\n", tmp_prop2); 
                prop2 = XInternAtom(disp, tmp_prop2, False);
                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                p_verbose("State 1: %s\n", tmp_prop1); 
                prop1 = XInternAtom(disp, tmp_prop1, False);
                client_msg(disp, get_active_window(disp), "_NET_WM_STATE", 
                  action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                p1="fullscreen";
                p2="above";
                prop1 = 0;
                prop2 = 0;
                action = _NET_WM_STATE_REMOVE;
                tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                p_verbose("State 2: %s\n", tmp_prop2); 
                prop2 = XInternAtom(disp, tmp_prop2, False);
                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                p_verbose("State 1: %s\n", tmp_prop1); 
                prop1 = XInternAtom(disp, tmp_prop1, False);
                g_free(tmp1);
                g_free(tmp_prop1);
                g_free(tmp2);
                g_free(tmp_prop2);
                client_msg(disp, get_active_window(disp), "_NET_WM_STATE", 
                      action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                if (strstr(get_window_title(disp,get_active_window(disp)),title)==NULL)
                {
                  for (i=0;i<win_count;i++)
                  {
                    if (win_pid_list[i]!=0) 
                    if (get_window_title(disp,win_pid_list[i])!=NULL)
                    if (strstr(get_window_title(disp,win_pid_list[i]),title)!=NULL)
                    {
                      action_window(disp,win_pid_list[i],'a');
                      can_close=0;
                    }  
                  }   
                }  else {
                  if (get_active_window(disp)!=0)
                  {
                    cur_win_id=get_active_window(disp);
                    unsigned long action;
                    gchar *tmp_prop2, *tmp2;
                    gchar *tmp_prop1, *tmp1;
                    char *p1="maximized_vert", *p2="maximized_horz";
                    Atom prop1 = 0;
                    Atom prop2 = 0;
                    can_close=1;

                    action = _NET_WM_STATE_REMOVE;
                    tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                    p_verbose("State 2: %s\n", tmp_prop2); 
                    prop2 = XInternAtom(disp, tmp_prop2, False);
                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                    p_verbose("State 1: %s\n", tmp_prop1); 
                    prop1 = XInternAtom(disp, tmp_prop1, False);
                    client_msg(disp, cur_win_id, "_NET_WM_STATE", 
                      action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                    p1="fullscreen";
                    p2="above";
                    prop1 = 0;
                    prop2 = 0;
                    action = _NET_WM_STATE_REMOVE;
                    tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                    p_verbose("State 2: %s\n", tmp_prop2); 
                    prop2 = XInternAtom(disp, tmp_prop2, False);
                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                    p_verbose("State 1: %s\n", tmp_prop1); 
                    prop1 = XInternAtom(disp, tmp_prop1, False);
                    g_free(tmp1);
                    g_free(tmp_prop1);
                    g_free(tmp2);
                    g_free(tmp_prop2);
                    client_msg(disp, cur_win_id, "_NET_WM_STATE", 
                        action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
//                  printf("%s %d \n",win_move,cur_win_id);
                    window_move_resize(disp,cur_win_id,win_move);
                  }
                }  
              }
            }  
          }  else {
            list_windows(disp,skip);
            if (win_pid_list[cur_win]==0)
            {
              cur_win=0;
              sprintf(text,"没有活动窗口");
            }  else  {
              if (get_window_title(disp,win_pid_list[cur_win])!=NULL)
              {
                if (cur_win>0) {
                  cur_win=cur_win-1;  
                } else  {
                  cur_win=win_count-1;
                } 
                sprintf(text,"%s",get_window_title(disp,win_pid_list[cur_win]));
                mytoggle = 1;
                mytoggle2 = 1;
              } else {
                sprintf(text,"没有活动窗口");
                cur_win=0;  
              }    
            } 
            mytoggle = 1;
            buffer = imlib_create_image(1000, 30);  
            font = imlib_load_font("Vera/8");
            if (font == NULL)
              font = imlib_load_font("wqy-zenhei.ttc/8");
            imlib_context_set_font(font);
            imlib_context_set_color(0, 0, 0, 255);
            imlib_get_text_size(text, &text_w, &text_h);
//            win2=XCreateWindow(disp,DefaultRootWindow(disp),screenX+screenWidth+4,screenY-18,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
            XRaiseWindow(disp,win2);
            XMapWindow(disp, win2);
            imlib_context_set_drawable(win2); 
//            imlib_context_set_image(buffer);
            imlib_context_set_image(buffer);
            imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
      //     imlib_free_color_range();
            imlib_context_set_image(buffer);
            imlib_render_image_on_drawable(0, 0); 
            imlib_context_set_image(buffer);
            imlib_context_set_font(font);
            imlib_context_set_color(0, 0, 0, 255);
            imlib_text_draw(5,2,text);
            imlib_context_set_image(buffer);
            imlib_context_set_drawable(win2); 
            imlib_render_image_on_drawable(0, 0); 
            imlib_context_set_image(buffer);
            imlib_free_image();
            imlib_context_set_font(font);
            imlib_free_font();
            imlib_context_set_image(im_bg);
            imlib_context_set_drawable(win); 
            system("killall iconrun3");	
          }
          break;
        }
      }
    }
    while (XPending(disp));
    imlib_context_set_blend(1);
    if(mytoggle == 1)
    {
      imlib_context_set_image(bigback);
      xl=x-24;
      yl=y-24;
    }else{
      imlib_context_set_image(back);
      xl=x-10;
      yl=y-10;
    }
    Imlib_Image        temp, temp2;
    temp = imlib_clone_image();
    imlib_context_set_image(temp);
    imlib_apply_filter
    ("bump_map_point(x=[],y=[],map=""blend.jpg);", &xl, &yl);
    imlib_context_set_image(back);
    imlib_render_image_on_drawable(0, 0);
    temp2 = im_bg;
    im_bg = temp;
    imlib_context_set_image(im_bg);
    imlib_context_set_blend(1);
    imlib_render_image_on_drawable(0, 0);
    im_bg = temp2;
    imlib_context_set_image(temp);
    imlib_free_image();
  }
  return 0;
}


void exposelist(void){
  //printf("exposelist\n");
  char app[2000];
  if ((bord==1) or (trans_wind<1))
  {
    sprintf(app , "icon-bord \"%s\" \"%s\" %d %f &" ,title,skip,bord,trans_wind);
    system(app);	
  }
  sprintf(app,"%s &",appToRun);
  printf("%s \n",app);
  system(app);
}
